function emp_dist = construct_gaussian(amin,amax,I, mu_G, sigma_G)
%Builds an initial truncated gaussian distribution

a   = linspace(amin,amax,I)';               % assets 1D  - I elements
da  = (amax-amin)/(I-1);     

emp_dist = exp((-(a-mu_G).^2)/2/sigma_G^2);
emp_dist = emp_dist /sum(emp_dist*da);

mean_truncated = sum(a.*emp_dist*da);
m   = mu_G;
step = da/100;
while abs(mean_truncated - mu_G) > step
    if mean_truncated >0 % shift to the left
        m = m - step;
    else
        m = m + step;     % shift to the right
    end
    emp_dist = exp((-(a-m).^2)/2/sigma_G^2);
    emp_dist = emp_dist /sum(emp_dist*da);
    mean_truncated = sum(a.*emp_dist*da);
end
% 
 