function emp_dist = construct_initial_dist(amin,amax,I)
%Data processing
%Builds the empirical distribution 
%  data = xlsread('distribution');
%  save distribution_data
cd ..\Data
load distribution_data

sample = data(5,1:end-1); %2009Q1
sample_w = data_weights(5,1:end-1);

sample = sample /100;
a   = linspace(amin,amax,I)';               % assets 1D  - I elements
da  = (amax-amin)/(I-1);     

emp_dist = zeros(size(a));
sigma_Q = 0.2; %smooth parameter
N     = length(sample)-1;

for i=1:N
    emp_dist = emp_dist + exp((-(a-sample(i)).^2)/2/sigma_Q^2) * sample_w(i);
end
emp_dist = emp_dist /sum(emp_dist*da);

cd ..\Code
% 
% Color1  = [0 0 1]; %blue
% style1 = '-';
% plot(a,emp_dist,'Color',Color1,'LineStyle',style1,'LineWidth',2)
% xlabel('Total financial assets','interpreter','latex','FontSize',16)
% title('Asset distribution across the Eurozone','interpreter','latex','FontSize',16)


