function pi_n = optimal_dynamics(parameters,r_bar_n,results,pi,Y_n)
%This code computes the optimal inflation rate under discretion with
%dynamics
% Developped by Nuo and Thomas (2015)
N  = parameters.N;
xi = parameters.xi;
f0 = results.f0;
pi_n          = zeros(1,N);                  %Initial guess
output        = zeros(1,N);
maxit         = parameters.maxit_pi;         % max number of iterations

 
pi_n(:)       = pi; % we assign the steady state value to all elements 

for l=1:maxit
    results           = HJB_dynamics(parameters,results, pi_n,r_bar_n,Y_n);
    f = KFE_dynamics(parameters,results,f0);
    for n=1:N
        output(n)       = sum(sum(f{n}(2:end-1,:).*results.aa(2:end-1,:).*0.5.*(results.V_n(3:end,:,n)-results.V_n(1:end-2,:,n)))) + parameters.psi*pi_n(n);
    end
    
    pi_n = pi_n - xi *output;
    dist = max(abs(output));
    disp('distance to convergence')
    disp(dist)
    disp('iteration')
    disp(l)    
    if dist<parameters.crit_pi
        disp('Optimal monetary converged, Iteration = ')
        disp(l)
        break
    end    
end

if l == maxit
     disp('maximum number of iterations  optimal inflation')
end
