% Welfare
Welfare_autarky = 1/rho *1/(1-gamma) * (((z1)^(1-gamma) -1)* la2/(la1+la2)+ ((z2)^(1-gamma)-1) * la1/(la1+la2));
Welfare1          = 1/rho * sum(sum(((results.c).^(1-gamma)-1)/(1-gamma) .* distribution *results.da));
Welfare2          =         sum(sum(results.V .* distribution *results.da));
% Checks
Q = results.Q;
Check1= -rho*results.V(:,1) + results.c(:,1).^(1-gamma)/(1-gamma) + ((delta/Q-delta-pi).*results.aa(:,1)+  results.zz(:,1)/Q - results.c(:,1)/Q) .* results.dV(:,1) + la1*(results.V(:,2)- results.V(:,1));   %Check
Check2= -rho*results.V(:,2) + results.c(:,2).^(1-gamma)/(1-gamma) + ((delta/Q-delta-pi).*results.aa(:,2)+  results.zz(:,2)/Q - results.c(:,2)/Q) .* results.dV(:,2) + la2*(results.V(:,1)- results.V(:,2));   %Check


%PLOTTING
% Color2  = [0 0 1]; %blue
% Color1  = [0 0.4 0.1]; %green
Color2  = [0 0 1]; %blue
Color1  = [0 0.4 0.1]; %green
style1 = '-';
style2 = '--';
figure(2)
subplot(221)
a = results.a;
plot(a/Y,results.V(:,1),'Color',Color1,'LineStyle',style1,'LineWidth',2)
hold on
plot(a/Y,results.V(:,2),'Color',Color2,'LineStyle',style2,'LineWidth',2)
%grid
xlabel('Assets, $a$','interpreter','latex','FontSize',16)
title('(a) Value function, $v(a)$','interpreter','latex','FontSize',16)
xlim([amin/Y 4])

subplot(222)
plot(a/Y,results.c(:,1),'Color',Color1,'LineStyle',style1,'LineWidth',2)
hold on
plot(a/Y,results.c(:,2),'Color',Color2,'LineStyle',style2,'LineWidth',2)
%grid
xlabel('Assets, $a$','interpreter','latex','FontSize',16)
title('(b) Consumption, $c(a)$','interpreter','latex','FontSize',16)
xlim([amin/Y 4])

subplot(223)
s  = results.zz/results.Q + results.aa*results.r - results.c/results.Q;
plot(a/Y,s(:,1),'Color',Color1,'LineStyle',style1,'LineWidth',2)
hold on
plot(a/Y,s(:,2),'Color',Color2,'LineStyle',style2,'LineWidth',2)
%grid
xlabel('Assets, $a$','interpreter','latex','FontSize',16)
title('(c) Drift, $s(a)$','interpreter','latex','FontSize',16)
xlim([amin/Y 4])

subplot(224)
plot(a/Y,distribution(:,1),'Color',Color1,'LineStyle',style1,'LineWidth',2)
hold on
plot(a/Y,distribution(:,2),'Color',Color2,'LineStyle',style2,'LineWidth',2)
%grid
xlabel('Assets, $a$','interpreter','latex','FontSize',16)
title('(d) Distribution, $f(a)$','interpreter','latex','FontSize',16)
xlim([amin/Y 4])
text(0,0,'$z$ = $z_1$','FontSize',14,'interpreter','latex')
text(0,0,'$z$ = $z_2$','FontSize',14,'interpreter','latex')


figure(8)
subplot(121)
a = results.a;
plot(a/Y,results.V(:,1),'Color',Color1,'LineStyle',style1,'LineWidth',2)
hold on
plot(a/Y,results.V(:,2),'Color',Color2,'LineStyle',style2,'LineWidth',2)
%grid
xlabel('Assets, $a$','interpreter','latex','FontSize',16)
title('(a) Value function, $v(a)$','interpreter','latex','FontSize',16)
xlim([amin/Y 4])

subplot(122)
plot(a/Y,results.c(:,1),'Color',Color1,'LineStyle',style1,'LineWidth',2)
hold on
plot(a/Y,results.c(:,2),'Color',Color2,'LineStyle',style2,'LineWidth',2)
%grid
xlabel('Assets, $a$','interpreter','latex','FontSize',16)
title('(b) Consumption, $c(a)$','interpreter','latex','FontSize',16)
xlim([amin/Y 4])
text(0,1,'$z$ = $z_1$','FontSize',14,'interpreter','latex')
text(0,1,'$z$ = $z_2$','FontSize',14,'interpreter','latex')


figure(1)
subplot(221)
plot(a/Y,distribution(:,1),'LineWidth',2)
hold on
plot(a/Y,distribution(:,2),'LineWidth',2)
%grid
xlabel('Assets, $a$','interpreter','latex','FontSize',16)
title('(a) Distribution, $f(a)$','interpreter','latex','FontSize',16)
xlim([amin/Y 4])
text(0,0,'$z$ = $z_1$','FontSize',14,'interpreter','latex')
text(0,0,'$z$ = $z_2$','FontSize',14,'interpreter','latex')

subplot(222)
s  = results.zz/results.Q + results.aa*results.r - results.c/results.Q;
plot(a/Y,s(:,1),'LineWidth',2)
hold on
plot(a/Y,s(:,2),'LineWidth',2)
%grid
xlabel('Assets, $a$','interpreter','latex','FontSize',16)
title('(b) Drift, $s(a)$','interpreter','latex','FontSize',16)
xlim([amin/Y 4])

subplot(223)
s1  = results.zz - results.c;
plot(a/Y,s1(:,1),'LineWidth',2)
hold on
plot(a/Y,s1(:,2),'LineWidth',2)
%grid
xlabel('Assets, $a$','interpreter','latex','FontSize',16)
title('(c) Net position, $y(a)-c(a)$','interpreter','latex','FontSize',16)
xlim([amin/Y 4])

subplot(224)
plot(a/Y,results.c(:,1),'LineWidth',2)
hold on
plot(a/Y,results.c(:,2),'LineWidth',2)
%grid
xlabel('Assets, $a$','interpreter','latex','FontSize',16)
title('(d) Consumption, $c(a)$','interpreter','latex','FontSize',16)
xlim([amin/Y 4])


% %PLOTTING
% Color1  = [0 0 1]; %blue
% Color2  = [0 0.4 0.1]; %green
% style1 = '-';
% style2 = '--';
% figure(1)
% subplot(221)
% a = results.a;
% plot(a/Y,results.V(:,1),'Color',Color1,'LineStyle',style1,'LineWidth',2)
% hold on
% plot(a/Y,results.V(:,2),'Color',Color2,'LineStyle',style2,'LineWidth',2)
% %grid
% xlabel('Assets, $a$','interpreter','latex','FontSize',16)
% title('Value function, $v(a)$','interpreter','latex','FontSize',16)
% xlim([amin/Y 4])
% 
% subplot(222)
% plot(a/Y,results.c(:,1),'Color',Color1,'LineStyle',style1,'LineWidth',2)
% hold on
% plot(a/Y,results.c(:,2),'Color',Color2,'LineStyle',style2,'LineWidth',2)
% %grid
% xlabel('Assets, $a$','interpreter','latex','FontSize',16)
% title('Consumption, $c(a)$','interpreter','latex','FontSize',16)
% xlim([amin/Y 4])
% 
% subplot(223)
% s  = results.zz/results.Q + results.aa*results.r - results.c/results.Q;
% plot(a/Y,s(:,1),'Color',Color1,'LineStyle',style1,'LineWidth',2)
% hold on
% plot(a/Y,s(:,2),'Color',Color2,'LineStyle',style2,'LineWidth',2)
% %grid
% xlabel('Assets, $a$','interpreter','latex','FontSize',16)
% title('Drift, $s(a)$','interpreter','latex','FontSize',16)
% xlim([amin/Y 4])
% 
% subplot(224)
% plot(a/Y,distribution(:,1),'Color',Color1,'LineStyle',style1,'LineWidth',2)
% hold on
% plot(a/Y,distribution(:,2),'Color',Color2,'LineStyle',style2,'LineWidth',2)
% %grid
% xlabel('Assets, $a$','interpreter','latex','FontSize',16)
% title('Distribution, $f(a)$','interpreter','latex','FontSize',16)
% xlim([amin/Y 4])
% text(0,0,'$z$ = $z_1$','FontSize',14,'interpreter','latex')
% text(0,0,'$z$ = $z_2$','FontSize',14,'interpreter','latex')
