
if mode == 1
    Color  = [1 0 0]; %blue
    line   = 2;
    style  = '-.';
    Color2 = 'ro';
    
else
    if mode == 2
        Color  = [0 0 1]; %blue
        line   = 2;
        style  = '--';
        Color2 = 'bo';       
    else

        Color  = [0 0.4 0.1]; %green
        line   = 2;
        style  = '-';
        Color2 = 'go';
    end
end   

stylex = ':';
%
% Computations
time  = (1:N) * dt;
range = find(results.a<0,1,'last');

for n=1:N
    A_n(n) = sum(sum(results.aa.*f{n} *results.da));
    C_n(n) = sum(sum(results.c_n(:,:,n).*f{n} *results.da));
    B_n(n) = sum(sum(results.aa(1:range,:).*f{n}(1:range,:) *results.da));
    U_n(n) = sum(sum(((results.c_n(:,:,n)).^(1-gamma)/(1-gamma)-psi/2*pi_n(n)^2) .*f{n} *results.da));
    discount(n) = exp(-rho*n*dt);
    W_n(n) = sum(sum(results.V_n(:,:,n).*f{n} *results.da));
    C_n_top(n) = sum(sum(results.c_n(range:end,:,n).*f{n}(range:end,:) *results.da));
    C_n_bottom(n) = sum(sum(results.c_n(1:range,:,n).*f{n}(1:range,:) *results.da));
    Y_n_top(n) = sum(sum(results.zz(range:end,:).*f{n}(range:end,:) *results.da));
    Y_n_bottom(n) = sum(sum(results.zz(1:range,:).*f{n}(1:range,:) *results.da));
end

A = sum(sum(results.aa.*distribution *results.da));
C= sum(sum(results.c.*distribution *results.da));
Y = sum(sum(results.zz.*distribution *results.da));
B = sum(sum(results.aa(1:range,:).*distribution(1:range,:) *results.da));

C_top    = sum(sum(results.c(range:end,:).*f0(range:end,:) *results.da));
C_bottom = sum(sum(results.c(1:range,:).*f0(1:range,:) *results.da));
Y_top    = sum(sum(results.zz(range:end,:).*f0(range:end,:) *results.da));
Y_bottom = sum(sum(results.zz(1:range,:).*f0(1:range,:) *results.da));
r_n = delta ./ results.Q_n -delta -pi_n;

time_max = 20;

%figure(3)
Moments

origin = 1;
time = time(1:end-origin+1);

subplot(221)
plot(time,(Y_n(origin:end)-Y_n(end))*100,'Color',Color,'LineStyle',style,'Linewidth',line)
title('(b) TFP, $Y$','FontSize',14,'interpreter','latex')
hold on
ylabel('Dev. from ss (p.p.)','FontSize',12,'interpreter','latex')
xlim([0 time_max])
grid on

subplot(222)
plot(time,(pi_n(origin:end)-pi_n(end))*100,'Color',Color,'LineStyle',style,'Linewidth',line)
title('(b)  Inflation, $\pi$','FontSize',14,'interpreter','latex')
hold on
ylabel('Dev. from ss (p.p.)','FontSize',12,'interpreter','latex')
xlim([0 time_max])
xlim([0 time_max])
grid on

subplot(223)
plot(time,(C_n(origin:end)/ C -1 )*100,'Color',Color,'LineStyle',style,'Linewidth',line)
title('(c) Consumption, $\bar{c}$','FontSize',14,'interpreter','latex')
hold on
ylabel('Dev. from ss (\%)','FontSize',12,'interpreter','latex')
xlabel('years','FontSize',12,'interpreter','latex')
xlim([0 time_max])
grid on

% Aggregate assets
subplot(224)
plot(time,-(A_n(origin:end)./A-1)*100,'Color',Color,'LineStyle',style,'Linewidth',line)
title('(d) Net assets, $\bar{a}$','FontSize',14,'interpreter','latex')
ylabel('Dev. from ss (\%)','FontSize',12,'interpreter','latex')
hold on
xlabel('years','FontSize',12,'interpreter','latex')
xlim([0 time_max])
grid on
if mode ==2
legend({'$\pi = 0$','Optimal'},'FontSize',12,'interpreter','latex')
end