% DYNAMICS OF CONSUMPTION


load zero_transition
%%
dc = (results.c_n(2:end,:,1) - results.c_n(1:end-1,:,1))/results.da;
dc(375,:) = (dc(374,:) + dc(377,:) )/2;
dc(376,:) = (dc(374,:) + dc(377,:) )/2;

figure(30)
subplot(121)
plot(results.c_n(:,1,1),[0; f{1}(2:end,1)./dc(:,1)],'Color',[1 0 0],'LineStyle','--','LineWidth',2)
hold on
plot(results.c_n(1,1,1),f{1}(1,1)/dc(1,1),'r*')

subplot(122)
plot(results.c_n(:,2,1),f{1}(:,2)./[dc(1,2); dc(:,2)],'Color',[1 0 0],'LineStyle','--','LineWidth',2)
hold on
%%
load face_transition
%%
dc = (results.c_n(2:end,:,1) - results.c_n(1:end-1,:,1))/results.da;
dc(375,:) = (dc(374,:) + dc(377,:) )/2;
dc(376,:) = (dc(374,:) + dc(377,:) )/2;
subplot(121)
plot(results.c_n(:,1,1),[0; f{1}(2:end,1)./dc(:,1)],'Color',[0 0.4 0.1],'LineStyle','-','LineWidth',2)
hold on
plot(results.c_n(1,1,1),f{1}(1,1)/dc(1,1),'g*')
% plot(results.c_n(2:end,1,end),f{end}(2:end,1),'Color',[0 0 1],'LineStyle','-.','LineWidth',2)
% plot(results.c_n(1,1,end),f{end}(1,1),'b*')
grid
xlabel('Consumption, $c$','interpreter','latex','FontSize',14)
title('(a) Unemployed, $f^c_0(c,y_1)$','interpreter','latex','FontSize',14)
xlim([0.6 1.23])

subplot(122)
plot(results.c_n(:,2,1),f{1}(:,2)./[dc(1,2); dc(:,2)],'Color',[0 0.4 0.1],'LineStyle','-','LineWidth',2)
% plot(results.c_n(:,1,end),f{1}(:,end),'Color',[0 0 1],'LineStyle','-.','LineWidth',2)
grid
xlabel('Consumption, $c$','interpreter','latex','FontSize',14)
title('(b) Employed, $f^c_0(c,y_2)$','interpreter','latex','FontSize',14)
% legend({'$\pi = 0$','Optimal'},'FontSize',12,'interpreter','latex')
xlim([0.6 1.23])
%%
figure(31)
subplot(221)
plot(results.a/Y,results.Q_n(1)*results.a,'Color',[0 0 0],'LineStyle','-','LineWidth',2)
grid
xlim([amin/Y 4])
% xlabel('Assets, $a$','interpreter','latex','FontSize',16)
title('(a) Net nominal position','interpreter','latex','FontSize',14)

subplot(222)
plot(results.a/Y,delta*results.a+z1-results.c_n(:,1,1),'Color',[0 0.4 0.1],'LineStyle','--','LineWidth',2)
hold on
plot(results.a/Y,delta*results.a+z2-results.c_n(:,2,1),'Color',[0 0 1],'LineStyle','-','LineWidth',2)
grid
legend({'Unemployed','Employed'},'FontSize',12,'interpreter','latex')
xlim([amin/Y 4])
% xlabel('Assets, $a$','interpreter','latex','FontSize',16)
title('(b) Unhedge interest rate exposure','interpreter','latex','FontSize',14)

subplot(223)
plot(results.a(2:end)/Y,f{1}(2:end,1),'Color',[0 0.4 0.1],'LineStyle','--','LineWidth',2)
hold on
plot(results.a/Y,f{1}(:,2),'Color',[0 0 1],'LineStyle','-','LineWidth',2)
grid
plot(results.a(1)/Y,f{1}(1,1),'g*')
xlim([amin/Y 4])
xlabel('Assets, $a$','interpreter','latex','FontSize',16)
title('(c) Wealth density','interpreter','latex','FontSize',14)

subplot(224)
plot(results.a/Y,(results.c_n(:,1,1)).^(-gamma),'Color',[0 0.4 0.1],'LineStyle','--','LineWidth',2)
hold on
plot(results.a/Y,(results.c_n(:,2,1)).^(-gamma),'Color',[0 0 1],'LineStyle','-','LineWidth',2)
grid
xlim([amin/Y 4])
xlabel('Assets, $a$','interpreter','latex','FontSize',16)
title('(d) Marginal utility of consumption','interpreter','latex','FontSize',14)



% %%
% % Plotting consumption inequality
% if mode == 1
%     Color  = [1 0 0]; %red
%     line   = 2;
%     style  = '--';
%     Color2 = 'bo';
%     del = 2;
% else
%     if mode == 0
%         Color  = [0 0 1]; %blue
%         line   = 2;
%         style  = '-.';
%         Color2 = 'ro';
%         del = 1;
%     else
%         
%         Color  = [0 0.4 0.1]; %green
%         line   = 2;
%         style  = '-';
%         Color2 = 'go';
%         del = 0;
%     end
% end
% 
% 
% emp =2; %employment status 1 or 2
% figure(33+emp)
% 
% if del ~= 2
%     subplot(331+del)
%     a = results.a;
%     plot(a/Y,(delta*a + results.z(emp) - results.c_n(:,emp,1))/results.Q_n(1),'Color',Color,'LineStyle','-','LineWidth',2)
%     hold on
%     plot(a/Y,(delta*a + results.z(emp) - results.c_n(:,emp,121))/results.Q_n(121),'Color',Color,'LineStyle','-.','LineWidth',2)
%     plot(a/Y,(delta*a + results.z(emp) - results.c_n(:,emp,241))/results.Q_n(241),'Color',Color,'LineStyle','--','LineWidth',2)
%     grid
%     if del ==0
%         title('Commitment','interpreter','latex','FontSize',16)
%         ylabel('New bonds','interpreter','latex','FontSize',14)
%     else
%         title('Discretion','interpreter','latex','FontSize',16)
%     end
%     xlim([amin/Y 4])
%     legend({'$t = 0$','$t = 10$','$t = 20$'},'FontSize',14,'interpreter','latex')
%     
%     subplot(334+del)
%     a = results.a;
%     plot(a/Y,results.c_n(:,emp,1),'Color',Color,'LineStyle','-','LineWidth',2)
%     hold on
%     plot(a/Y,results.c_n(:,emp,121),'Color',Color,'LineStyle','-.','LineWidth',2)
%     plot(a/Y,results.c_n(:,emp,241),'Color',Color,'LineStyle','--','LineWidth',2)
%     grid
%     if del ==0
%         ylabel('Consumption','interpreter','latex','FontSize',14)
%     end
%     xlim([amin/Y 4])
%     
%     subplot(337+del)
%     a = results.a;
%     plot(a/Y,f{1}(:,emp),'Color',Color,'LineStyle','-','LineWidth',2)
%     hold on
%     plot(a/Y,f{121}(:,emp),'Color',Color,'LineStyle','-.','LineWidth',2)
%     plot(a/Y,f{241}(:,emp),'Color',Color,'LineStyle','--','LineWidth',2)
%     grid
%     if del ==0
%         ylabel('Density','interpreter','latex','FontSize',14)
%     end
%     xlim([amin/Y 4])
%     xlabel('Assets, $a$','interpreter','latex','FontSize',16)
% end
% 
% subplot(333)
% a = results.a;
% plot(a/Y,(delta*a + results.z(emp) - results.c_n(:,emp,1))/results.Q_n(1),'Color',Color,'LineStyle',style,'LineWidth',2)
% hold on
% grid
% title('Optimal vs. $\pi = 0$ ($t = 0$)','interpreter','latex','FontSize',16)
% xlim([amin/Y 4])
% ylabel('New bonds ($t = 0$)','interpreter','latex','FontSize',14)
% %legend({'Commitment','Discretion','$\pi = 0$'},'FontSize',14,'interpreter','latex')
% 
% subplot(336)
% a = results.a;
% plot(a/Y,results.c_n(:,emp,1),'Color',Color,'LineStyle',style,'LineWidth',2)
% hold on
% grid
% xlim([amin/Y 4])
% ylabel('Consumption ($t = 0$)','interpreter','latex','FontSize',14)
% 
% subplot(339)
% a = results.a;
% plot(a/Y,f{1}(:,emp),'Color',Color,'LineStyle',style,'LineWidth',2)
% hold on
% grid
% xlim([amin/Y 4])
% xlabel('Assets, $a$','interpreter','latex','FontSize',16)
% ylabel('Density ($t = 0$)','interpreter','latex','FontSize',14)



% %%
% subplot(322)
% a = results.a;
% plot(a/Y,(delta*a + results.z(2) - results.c_n(:,2,1))/results.Q_n(1),'Color',Color,'LineStyle',style,'LineWidth',2)
% hold on
% %grid
% xlabel('Assets, $a$','interpreter','latex','FontSize',16)
% title('(b) Initial bond issuance - employed','interpreter','latex','FontSize',16)
% xlim([amin/Y 4])
% %legend({'Commitment','Discretion','$\pi = 0$'},'FontSize',14,'interpreter','latex')
%
% subplot(323)
% a = results.a;
% plot(a/Y,results.c_n(:,1,1),'Color',Color,'LineStyle',style,'LineWidth',2)
% hold on
% %grid
% xlabel('Assets, $a$','interpreter','latex','FontSize',16)
% title('(c) Initial consumption - unemployed, $c(0,a,y_1)$','interpreter','latex','FontSize',16)
% xlim([amin/Y 4])
% %legend({'Commitment','Discretion','$\pi = 0$'},'FontSize',14,'interpreter','latex')
%
% subplot(324)
% a = results.a;
% plot(a/Y,results.c_n(:,2,1),'Color',Color,'LineStyle',style,'LineWidth',2)
% hold on
% %grid
% xlabel('Assets, $a$','interpreter','latex','FontSize',16)
% title('(d) Initial consumption - employed, $c(0,a,y_2)$','interpreter','latex','FontSize',16)
% xlim([amin/Y 4])
%
% subplot(325)
% a = results.a;
% plot(a/Y,f{1}(:,1),'Color',Color,'LineStyle','-','LineWidth',2)
% hold on
% %grid
% xlabel('Assets, $a$','interpreter','latex','FontSize',16)
% title('(e) Initial density  - unemployed, $f(0,a,y_1)$','interpreter','latex','FontSize',16)
% xlim([amin/Y 4])
%
% subplot(326)
% a = results.a;
% plot(a/Y,f{1}(:,2),'Color',Color,'LineStyle','-','LineWidth',2)
% hold on
% %grid
% xlabel('Assets, $a$','interpreter','latex','FontSize',16)
% title('(f) Initial density  - employed, $f(0,a,y_2)$','interpreter','latex','FontSize',16)
% xlim([amin/Y 4])
%
% %%
% figure(1)
% style = '-';
%
% subplot(221)
% a = results.a;
% plot(a/Y,results.c_n(:,1,1),'Color',Color,'LineStyle',style,'LineWidth',2)
% hold on
% plot(a/Y,results.c_n(:,1,121),'Color',Color,'LineStyle','-.','LineWidth',2)
% %grid
% xlabel('Assets, $a$','interpreter','latex','FontSize',16)
% title('(a) Consumption - unemployed, $c(t,a,y_1)$','interpreter','latex','FontSize',16)
% xlim([amin/Y 4])
% legend({'$t = 0$','$t = 10$'},'FontSize',14,'interpreter','latex')
%
% subplot(222)
% a = results.a;
% plot(a/Y,results.c_n(:,2,1),'Color',Color,'LineStyle',style,'LineWidth',2)
% hold on
% plot(a/Y,results.c_n(:,2,121),'Color',Color,'LineStyle','-.','LineWidth',2)
% %grid
% xlabel('Assets, $a$','interpreter','latex','FontSize',16)
% title('(b) Consumption - employed, $c(t,a,y_2)$','interpreter','latex','FontSize',16)
% xlim([amin/Y 4])
%
% subplot(223)
% a = results.a;
% plot(a/Y,f{1}(:,1),'Color',Color,'LineStyle','-','LineWidth',2)
% hold on
% plot(a/Y,f{121}(:,1),'Color',Color,'LineStyle','-.','LineWidth',2)
% %grid
% xlabel('Assets, $a$','interpreter','latex','FontSize',16)
% title('(c) Density  - unemployed, $f(t,a,y_1)$','interpreter','latex','FontSize',16)
% xlim([amin/Y 4])
%
% subplot(224)
% a = results.a;
% plot(a/Y,f{1}(:,2),'Color',Color,'LineStyle','-','LineWidth',2)
% hold on
% plot(a/Y,f{121}(:,2),'Color',Color,'LineStyle','-.','LineWidth',2)
% %grid
% xlabel('Assets, $a$','interpreter','latex','FontSize',16)
% title('(d) Density  - employed, $f(t,a,y_2)$','interpreter','latex','FontSize',16)
% xlim([amin/Y 4])