% PLOTTING "INSPECTING THE MECHANISM"

load gaussian

for i = 1:length(mu_G_n)
    distribution_sigma(:,i) = construct_gaussian(amin,amax,I, mu_G_n(i), sigma_G_n(i));
end
range1 = 1:7;
range2 = [1, 8:length(mu_G_n)];
    
figure(8)
%distributions sigma
subplot(121)
line = 2;

plot(results.a,distribution_sigma(:,range1),'Linewidth',line)
title('(a) Initial distribution, $f(0)$','FontSize',18,'interpreter','latex') 
xlabel('Assets, $a$','interpreter','latex','FontSize',16)
xlim([-4 4])
ylim([0 2])
text(0,0,'$\sigma$ = 0.01','FontSize',14,'interpreter','latex')
text(0,0,'$\sigma$ = 0.4','FontSize',14,'interpreter','latex')
text(0,0,'$\sigma$ = 0.8','FontSize',14,'interpreter','latex')
text(0,0,'$\sigma$ = 1.2','FontSize',14,'interpreter','latex')
text(0,0,'$\sigma$ = 1.6','FontSize',14,'interpreter','latex')
text(0,0,'$\sigma$ = 1.9','FontSize',14,'interpreter','latex')
text(0,0,'$\sigma$ = 2.1','FontSize',14,'interpreter','latex')


% subplot(123)
% line = 2;
% plot(results.a,distribution_sigma(:,range2),'Linewidth',line)
% title('(c) Initial distribution, $f(0)$','FontSize',18,'interpreter','latex') 
% xlabel('Assets, $a$','interpreter','latex','FontSize',16)
% xlim([-4 4])
% ylim([0 2])
% text(0,0,'$\mu$ = 0','FontSize',14,'interpreter','latex')
% text(0,0,'$\mu$ = -0.5','FontSize',14,'interpreter','latex')
% text(0,0,'$\mu$ = -1','FontSize',14,'interpreter','latex')
% text(0,0,'$\mu$ = -1.5','FontSize',14,'interpreter','latex')

subplot(122)
line = 2;
plot(sigma_G_n(range1),100*pi_g(range1),'LineStyle','-','Linewidth',line)
title('(b) Initial inflation, $\pi(0)$','FontSize',18,'interpreter','latex') 
xlabel('$\sigma$','interpreter','latex','FontSize',16) 
%ylim([0 max(100*pi_g(range1))])
% 
% subplot(224)
% line = 2;
% plot(mu_G_n(range2),100*pi_g(range2),'LineStyle','-','Linewidth',line)
% title('(d) Initial inflation, $\pi(0)$','FontSize',18,'interpreter','latex')
% xlabel('$\mu$','interpreter','latex','FontSize',16) 
% %ylim([0 max(100*pi_g(range2))])

