% This code performs the robustness analysis of r_bar 

param_n = 0.0281:0.0001:0.0300;   % r_bar

for n = 1:length(param_n)
    
    parameters.r_bar  = param_n(n);
    flag_mu      = 0;
    pi           = fzero(@(pi) ramsey(parameters,pi,flag_mu), pi_guess);
    results      = HJB_stationary(parameters,pi);
    distribution = KFE_stationary(parameters,results);
    Moments
    A_n(n) = A;
    C_n(n) = C;
    Y_n(n) = Y;
    B_n(n) = B;
    pi_n(n)= pi;
    
    mu(n)           =  1/ results.Q *(psi*pi + sum(sum(distribution(2:end-1,:).*results.aa(2:end-1,:).*0.5.*(results.V(3:end,:)-results.V(1:end-2,:))))) ;
    Comm(n)         =  1/psi *mu(n) *results.Q;  
    Red(n)          = -1/psi *sum(sum(distribution(2:end-1,:).*results.aa(2:end-1,:).*0.5.*(results.V(3:end,:)-results.V(1:end-2,:))));
  
    
end

save robustness
%%
figure(11)
plot(100*(rho-param_n),100*Comm,'b-o','Linewidth',2)
hold on
plot(100*(rho-param_n),100*Red,'r--o','Linewidth',2)
plotyy(100*(rho-param_n),100*Comm,100*(rho-param_n),100*pi_n)
xlabel(' $\bar{r} -\rho$ (percent)','interpreter','latex','FontSize',16)

text(1e-3,0,'Redistributive  component (percent), lhs','FontSize',14,'interpreter','latex')
text(1e-3,0,'Commitment  component (percent), lhs','FontSize',14,'interpreter','latex')
text(1e-3,0,'Steady-state inflation, $\pi$ (percent), rhs','FontSize',14,'interpreter','latex')
